Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/LineProjectionBasedEPCreator.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/LineProjectionBasedEPCreator.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/LineProjectionBasedEPCreator.cs	(revision 15554)
@@ -15,15 +15,6 @@
   public class LineProjectionBasedEPCreator : ExtremePointCreator {
 
-
-
-
     protected override void UpdateExtremePoints(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
-      // After a item has been placed, the residual space has to be recalculated.
-      //RecalculateResidualSpaces(binPacking);
-
-      //GenerateNewExtremePointsForItem(binPacking, item, position);
-
       binPacking.ExtremePoints.Clear();
-      binPacking.ResidualSpaces.Clear();
 
       foreach (var i in binPacking.Items) {
@@ -32,15 +23,15 @@
         GenerateNewExtremePointsForItem(binPacking, it, p);
       }
-      //RecalculateResidualSpaces(binPacking);
-    }
-
-    /// <summary>
-    /// Adds an new extreme point an the related residual space to a given bin packing.
-    /// - The given position has to be valid
-    /// - The residual space must not be zero
-    /// </summary>
-    /// <param name="binPacking"></param>
-    /// <param name="position"></param>
-    /// <returns></returns>
+    }
+
+    /// <summary>
+    /// Adds a new extreme point an the related residual spaces to a given bin packing.
+    /// - The given position has to be valid.
+    /// - The extreme point does not exist in the bin packing.
+    /// - There must be at minimum one valid residual space. A residual space is invalid if the space is zero.
+    /// </summary>
+    /// <param name="binPacking"></param>
+    /// <param name="position"></param>
+    /// <returns>True = the given point and its related residual spaces were successfully added to the bin packing</returns>
     protected override bool AddExtremePoint(BinPacking3D binPacking, PackingPosition position) {
       if (position == null) {
@@ -48,20 +39,50 @@
       }
 
-      if (PointIsInItem(binPacking, new Vector3D(position))) {
+      if (PointIsInAnyItem(binPacking, new Vector3D(position))) {
         return false;
       }
 
+      if (binPacking.ExtremePoints.ContainsKey(position)) {
+        return false;
+      }
+
       var rs = CalculateResidualSpace(binPacking, new Vector3D(position));
 
-      if (rs.IsZero()) {
+      if (rs.Count() <= 0) {
         return false;
       }
 
-      if (!binPacking.ExtremePoints.Add(position)) {
+      // todo 
+      /*
+       ist der extrempunkt im residual space eines anderen muss ueberprueft werden:
+          - ist der andere ep in der luft, kann auch dieser hinzugefuegt werden.
+          - hat der andere ep ein item unterhalb, darf dieser nicht hinzugefuegt werden.
+       -> neu methode basierend auf IsWithinResidualSpaceOfAnotherExtremePoint, die den ep oder rs zurueck gibt, der einen anderen rs einschließt.
+          eventuell gehoert diese logik in den ResidualSpaceCreator.
+      if (LiesOnAnyItem(binPacking, position)) {
         return false;
-      }
-
-      binPacking.ResidualSpaces.Add(position, rs);
+      }*/
+
+      binPacking.ExtremePoints.Add(position, rs);
       return true;
+    }
+
+    private bool LiesOnAnyItem(BinPacking3D binPacking, PackingPosition position) {
+      if (position.Y == 0) {
+        return true;
+      }
+
+      var items = binPacking.Items.Where(x => {
+        var itemPosition = binPacking.Positions[x.Key];
+        var item = x.Value;
+        int width = itemPosition.Rotated ? item.Depth : item.Width;
+        int depth = itemPosition.Rotated ? item.Width : item.Depth;
+
+        return itemPosition.Y + item.Height == position.Y &&
+               itemPosition.X <= position.X && position.X < itemPosition.X + width &&
+               itemPosition.Z <= position.Z && position.Z < itemPosition.Z + depth;
+      });
+
+      return items.Count() > 0;
     }
 
@@ -83,5 +104,5 @@
     /// <summary>
     /// This method creates extreme points by using a point projection based method.
-    /// For each item there will be three points created and each of the point will be projected twice.
+    /// For each item there will be created three points and each of the points will be projected twice.
     /// The direction of the projection depends on position of the point.
     /// </summary>
@@ -118,5 +139,7 @@
       if (sourcePoint.X < binPacking.BinShape.Width && sourcePoint.Y < binPacking.BinShape.Height && sourcePoint.Z < binPacking.BinShape.Depth) {
         Vector3D point = projectionMethod?.Invoke(binPacking, sourcePoint);
-        AddExtremePoint(binPacking, new PackingPosition(position.AssignedBin, point.X, point.Y, point.Z));
+        if (point != null) {
+          AddExtremePoint(binPacking, new PackingPosition(position.AssignedBin, point.X, point.Y, point.Z));
+        }
       }
     }
@@ -141,23 +164,36 @@
 
       foreach (var ep in GetEpsOnLeft(binPacking, newItem, position)) {
-        AddExtremePoint(binPacking, ep);
+        AddExtremePoint(binPacking, ep.Key);
       }
 
       foreach (var ep in GetEpsBelow(binPacking, newItem, position)) {
-        AddExtremePoint(binPacking, ep);
+        AddExtremePoint(binPacking, ep.Key);
       }
 
       foreach (var ep in GetEpsBehind(binPacking, newItem, position)) {
-        AddExtremePoint(binPacking, ep);
+        AddExtremePoint(binPacking, ep.Key);
       }
     }
     #endregion
 
-
+    /// <summary>
+    /// Updates the residual spaces.
+    /// It removes not needed ones.
+    /// A residual space will be removed if the space is a subspace of another one and 
+    /// the current one has no item below or both have an item below. 
+    /// </summary>
+    /// <param name="binPacking"></param>
+    /// <param name="item"></param>
+    /// <param name="position"></param>
     protected override void UpdateResidualSpace(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
-      return;
-    }
-
-    private bool PointIsInItem(BinPacking3D binPacking, Vector3D point) {
+    }
+
+    /// <summary>
+    /// Returns true if any item in the bin packing encapsulates the given point
+    /// </summary>
+    /// <param name="binPacking"></param>
+    /// <param name="point"></param>
+    /// <returns></returns>
+    private bool PointIsInAnyItem(BinPacking3D binPacking, Vector3D point) {
       foreach (var item in binPacking.Items) {
         PackingPosition position = binPacking.Positions[item.Key];
@@ -184,23 +220,4 @@
     }
 
-    /// <summary>
-    /// Recalculates the residual spaces if needed.
-    /// It checks if an item is in an residual space and if so the residual space will be recalculated.
-    /// If the residual space has gone to zero, this residual space and its related extreme point will be removed.
-    /// </summary>
-    /// <param name="binPacking"></param>
-    private void RecalculateResidualSpaces(BinPacking3D binPacking) {
-      var recalculatedSpaces = new Dictionary<PackingPosition, ResidualSpace>();
-      foreach (var ep in binPacking.ExtremePoints.ToList()) {
-        var newRs = CalculateResidualSpace(binPacking, new Vector3D(ep));
-        if (!newRs.IsZero() && !PointIsInItem(binPacking, new Vector3D(ep))) {
-          recalculatedSpaces.Add(ep, newRs);
-        } else {
-          binPacking.ExtremePoints.Remove(ep);
-        }
-      }
-      binPacking.ResidualSpaces = recalculatedSpaces;
-    }
-
     protected IEnumerable<Tuple<PackingPosition, PackingItem>> GetItemsBelow(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
       return binPacking.Items.Select(x => new {
@@ -228,31 +245,44 @@
 
     /// <summary>
-    /// Returns the extremepoints on the left side of an given item
-    /// </summary>
-    /// <param name="item"></param>
-    /// <param name="position"></param>
-    /// <returns></returns>
-    private IList<PackingPosition> GetEpsOnLeft(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
-      IList<PackingPosition> eps = new List<PackingPosition>();
+    /// Returns the extreme points and its related residual spaces on the left side of an given item.
+    /// This extreme points are being created by intersecting two edges on the left side of the given item 
+    /// (left - in front, left - on top) with all edges on the right side of all other items int the bin packing.
+    /// </summary>
+    /// <param name="item"></param>
+    /// <param name="position"></param>
+    /// <returns></returns>
+    private IDictionary<PackingPosition, IEnumerable<ResidualSpace>> GetEpsOnLeft(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
+      var eps = new SortedList<PackingPosition, IEnumerable<ResidualSpace>>();
       IEnumerable<Tuple<PackingPosition, PackingItem>> items = GetItemsOnLeft(binPacking, item, position);
       var edges = GetProjectionEdgesOnLeft(item, position);
 
       foreach (var otherItem in items) {
+        if (position.Equals(otherItem.Item1)) {
+          continue;
+        }
+
         var otherItemEdges = GetEdgesOnRight(otherItem.Item2, otherItem.Item1);
+        // left - in front
         foreach (var ep in IntersectionsForItem(edges[0], otherItemEdges, new Vector3D(1, 0, 0))) {
           if (ep.X < binPacking.BinShape.Width && ep.Y < binPacking.BinShape.Height && ep.Z < binPacking.BinShape.Depth) {
+            // As this edge has a vertical direction, every point of intersection won't have an item below.
+            // So finally it is being projected down.
             var point = ProjectDown(binPacking, ProjectLeft(binPacking, ep));
-            var residualSpace = CalculateResidualSpace(binPacking, point);
-            if (!residualSpace.IsZero()) {
-              eps.Add(point.ToPackingPosition(position.AssignedBin));
+            var residualSpaces = CalculateResidualSpace(binPacking, point);
+            var newExtremePoint = point.ToPackingPosition(position.AssignedBin);
+            if (residualSpaces.Count() > 0 && !eps.ContainsKey(newExtremePoint)) {
+              eps.Add(newExtremePoint, residualSpaces);
             }
           }
         }
+
+        // left - on top
         foreach (var ep in IntersectionsForItem(edges[1], otherItemEdges, new Vector3D(1, 0, 0))) {
           if (ep.X < binPacking.BinShape.Width && ep.Y < binPacking.BinShape.Height && ep.Z < binPacking.BinShape.Depth) {
             var point = ProjectLeft(binPacking, ep);
-            var residualSpace = CalculateResidualSpace(binPacking, point);
-            if (!residualSpace.IsZero()) {
-              eps.Add(point.ToPackingPosition(position.AssignedBin));
+            var residualSpaces = CalculateResidualSpace(binPacking, point);
+            var newExtremePoint = point.ToPackingPosition(position.AssignedBin);
+            if (residualSpaces.Count() > 0 && !eps.ContainsKey(newExtremePoint)) {
+              eps.Add(newExtremePoint, residualSpaces);
             }
           }
@@ -264,31 +294,42 @@
 
     /// <summary>
-    /// Returns the extremepoints below of an given item
-    /// </summary>
-    /// <param name="item"></param>
-    /// <param name="position"></param>
-    /// <returns></returns>
-    private IList<PackingPosition> GetEpsBelow(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
-      IList<PackingPosition> eps = new List<PackingPosition>();
+    /// Returns the extreme points and its related residual spaces below of an given item.
+    /// This extreme points are being created by intersecting two edges below of the given item 
+    /// (below - in front, below - right) with all edges on top side of all other items int the bin packing.
+    /// </summary>
+    /// <param name="item"></param>
+    /// <param name="position"></param>
+    /// <returns></returns>
+    private IDictionary<PackingPosition, IEnumerable<ResidualSpace>> GetEpsBelow(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
+      var eps = new SortedList<PackingPosition, IEnumerable<ResidualSpace>>();
       IEnumerable<Tuple<PackingPosition, PackingItem>> items = GetItemsBelow(binPacking, position);
       var edges = GetProjectionEdgesBelow(item, position);
 
       foreach (var otherItem in items) {
+        if (position.Equals(otherItem.Item1)) {
+          continue;
+        }
+
         var otherItemEdges = GetEdgesOnTop(otherItem.Item2, otherItem.Item1);
+        // below - in front
         foreach (var ep in IntersectionsForItem(edges[0], otherItemEdges, new Vector3D(0, 1, 0))) {
           if (ep.X < binPacking.BinShape.Width && ep.Y < binPacking.BinShape.Height && ep.Z < binPacking.BinShape.Depth) {
             var point = ProjectDown(binPacking, ep);
-            var residualSpace = CalculateResidualSpace(binPacking, point);
-            if (!residualSpace.IsZero()) {
-              eps.Add(point.ToPackingPosition(position.AssignedBin));
+            var residualSpaces = CalculateResidualSpace(binPacking, point);
+            var newExtremePoint = point.ToPackingPosition(position.AssignedBin);
+            if (residualSpaces.Count() > 0 && !eps.ContainsKey(newExtremePoint)) {
+              eps.Add(newExtremePoint, residualSpaces);
             }
           }
         }
+
+        // below - right
         foreach (var ep in IntersectionsForItem(edges[1], otherItemEdges, new Vector3D(0, 1, 0))) {
           if (ep.X < binPacking.BinShape.Width && ep.Y < binPacking.BinShape.Height && ep.Z < binPacking.BinShape.Depth) {
             var point = ProjectDown(binPacking, ep);
-            var residualSpace = CalculateResidualSpace(binPacking, point);
-            if (!residualSpace.IsZero()) {
-              eps.Add(point.ToPackingPosition(position.AssignedBin));
+            var residualSpaces = CalculateResidualSpace(binPacking, point);
+            var newExtremePoint = point.ToPackingPosition(position.AssignedBin);
+            if (residualSpaces.Count() > 0 && !eps.ContainsKey(newExtremePoint)) {
+              eps.Add(newExtremePoint, residualSpaces);
             }
           }
@@ -299,31 +340,44 @@
 
     /// <summary>
-    /// Returns 
-    /// </summary>
-    /// <param name="item"></param>
-    /// <param name="position"></param>
-    /// <returns></returns>
-    private IList<PackingPosition> GetEpsBehind(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
-      IList<PackingPosition> eps = new List<PackingPosition>();
+    /// Returns the extreme points and its related residual spaces below of an given item.
+    /// This extreme points are being created by intersecting two edges below of the given item 
+    /// (right - behind, on top - behind) with all edges on top side of all other items int the bin packing.
+    /// </summary>
+    /// <param name="item"></param>
+    /// <param name="position"></param>
+    /// <returns></returns>
+    private IDictionary<PackingPosition, IEnumerable<ResidualSpace>> GetEpsBehind(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
+      var eps = new SortedList<PackingPosition, IEnumerable<ResidualSpace>>();
       IEnumerable<Tuple<PackingPosition, PackingItem>> items = GetItemsBehind(binPacking, position);
       var edges = GetProjectionEdgesBehind(item, position);
 
       foreach (var otherItem in items) {
+        if (position.Equals(otherItem.Item1)) {
+          continue;
+        }
+
         var otherItemEdges = GetEdgesInFront(otherItem.Item2, otherItem.Item1);
+        // right - behind
         foreach (var ep in IntersectionsForItem(edges[0], otherItemEdges, new Vector3D(0, 0, 1))) {
           if (ep.X < binPacking.BinShape.Width && ep.Y < binPacking.BinShape.Height && ep.Z < binPacking.BinShape.Depth) {
+            // As this edge has a vertical direction, every point of intersection won't have an item below.
+            // So finally it is being projected down.
             var point = ProjectDown(binPacking, ProjectBackward(binPacking, ep));
-            var residualSpace = CalculateResidualSpace(binPacking, point);
-            if (!residualSpace.IsZero()) {
-              eps.Add(point.ToPackingPosition(position.AssignedBin));
+            var residualSpaces = CalculateResidualSpace(binPacking, point);
+            var newExtremePoint = point.ToPackingPosition(position.AssignedBin);
+            if (residualSpaces.Count() > 0 && !eps.ContainsKey(newExtremePoint)) {
+              eps.Add(newExtremePoint, residualSpaces);
             }
           }
         }
+
+        // on top - behind
         foreach (var ep in IntersectionsForItem(edges[1], otherItemEdges, new Vector3D(0, 0, 1))) {
           if (ep.X < binPacking.BinShape.Width && ep.Y < binPacking.BinShape.Height && ep.Z < binPacking.BinShape.Depth) {
             var point = ProjectBackward(binPacking, ep);
-            var residualSpace = CalculateResidualSpace(binPacking, point);
-            if (!residualSpace.IsZero()) {
-              eps.Add(point.ToPackingPosition(position.AssignedBin));
+            var residualSpaces = CalculateResidualSpace(binPacking, point);
+            var newExtremePoint = point.ToPackingPosition(position.AssignedBin);
+            if (residualSpaces.Count() > 0 && !eps.ContainsKey(newExtremePoint)) {
+              eps.Add(newExtremePoint, residualSpaces);
             }
           }
@@ -452,8 +506,12 @@
 
     /// <summary>
-    /// 
+    /// Returns a collection of points where a given edge (projectedEdge) intersects with other edges.
+    /// The given edge (projectedEdge) will be projected by using the given vector direction
+    /// and a edge of the given edge collection.
+    /// The returned collecten can be empty.
     /// </summary>
     /// <param name="projectedEdge"></param>
     /// <param name="edges"></param>
+    /// <param name="direction"></param>
     /// <returns></returns>
     private IEnumerable<Vector3D> IntersectionsForItem(Edge3D projectedEdge, Edge3D[] edges, Vector3D direction = null) {
@@ -486,10 +544,15 @@
     #endregion
 
-    
-    protected override ResidualSpace CalculateResidualSpace(BinPacking3D binPacking, Vector3D pos) {
-      return ResidualSpaceCalculatorFactory.CreateCalculator().CalculateResidualSpaces(binPacking, pos).First();
+    /// <summary>
+    /// Calculates the residual spaces for an extreme point.
+    /// </summary>
+    /// <param name="binPacking"></param>
+    /// <param name="pos"></param>
+    /// <returns></returns>
+    protected override IEnumerable<ResidualSpace> CalculateResidualSpace(BinPacking3D binPacking, Vector3D pos) {
+      return ResidualSpaceCalculatorFactory.CreateCalculator().CalculateResidualSpaces(binPacking, pos);
     }
   }
 
-  
+
 }
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/PointProjectionBasedEPCreator.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/PointProjectionBasedEPCreator.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/PointProjectionBasedEPCreator.cs	(revision 15554)
@@ -31,41 +31,45 @@
     
     protected override void UpdateResidualSpace(BinPacking3D binPacking, PackingItem item, PackingPosition position) {
-      foreach (var ep in binPacking.ExtremePoints.ToList()) {
-        var rs = binPacking.ResidualSpaces[ep];
-        var depth = position.Rotated ? item.Width : item.Depth;
-        var width = position.Rotated ? item.Depth : item.Width;
-        var changed = false;
-        if (ep.Z >= position.Z && ep.Z < position.Z + depth) {
-          if (ep.X <= position.X && ep.Y >= position.Y && ep.Y < position.Y + item.Height) {
-            var diff = position.X - ep.X;
-            var newRSX = Math.Min(rs.Width, diff);
-            rs = ResidualSpace.Create(newRSX, rs.Height, rs.Depth);
+      foreach (var extremePoint in binPacking.ExtremePoints.ToList()) {
+        var ep = extremePoint.Key;
+        var residualSpaces = extremePoint.Value as IList<ResidualSpace>;
+        for (int i = 0; i < residualSpaces.Count(); i++) {
+          var rs = residualSpaces[i];
+          var depth = position.Rotated ? item.Width : item.Depth;
+          var width = position.Rotated ? item.Depth : item.Width;
+          var changed = false;
+          if (ep.Z >= position.Z && ep.Z < position.Z + depth) {
+            if (ep.X <= position.X && ep.Y >= position.Y && ep.Y < position.Y + item.Height) {
+              var diff = position.X - ep.X;
+              var newRSX = Math.Min(rs.Width, diff);
+              rs = ResidualSpace.Create(newRSX, rs.Height, rs.Depth);
+              changed = true;
+            }
+            if (ep.Y <= position.Y && ep.X >= position.X && ep.X < position.X + width) {
+              var diff = position.Y - ep.Y;
+              var newRSY = Math.Min(rs.Height, diff);
+              rs = ResidualSpace.Create(rs.Width, newRSY, rs.Depth);
+              changed = true;
+            }
+          }
+
+          if (ep.Z <= position.Z &&
+              ep.Y >= position.Y && ep.Y < position.Y + item.Height &&
+              ep.X >= position.X && ep.X < position.X + width) {
+            var diff = position.Z - ep.Z;
+            var newRSZ = Math.Min(rs.Depth, diff);
+            rs = ResidualSpace.Create(rs.Width, rs.Height, newRSZ);
             changed = true;
           }
-          if (ep.Y <= position.Y && ep.X >= position.X && ep.X < position.X + width) {
-            var diff = position.Y - ep.Y;
-            var newRSY = Math.Min(rs.Height, diff);
-            rs = ResidualSpace.Create(rs.Width, newRSY, rs.Depth);
-            changed = true;
+
+          if (changed) {
+            if (!rs.IsZero() && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, new Vector3D(ep), rs)) {
+              residualSpaces[i] = rs;
+            } else {
+              binPacking.ExtremePoints.Remove(ep);
+              break;
+            }
           }
-        }
-
-        if (ep.Z <= position.Z &&
-            ep.Y >= position.Y && ep.Y < position.Y + item.Height &&
-            ep.X >= position.X && ep.X < position.X + width) {
-          var diff = position.Z - ep.Z;
-          var newRSZ = Math.Min(rs.Depth, diff);
-          rs = ResidualSpace.Create(rs.Width, rs.Height, newRSZ);
-          changed = true;
-        }
-
-        if (changed) {
-          if (!rs.IsZero() && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, new Vector3D(ep), rs)) {
-            binPacking.ResidualSpaces[ep] = rs;
-          } else {
-            binPacking.ExtremePoints.Remove(ep);
-            binPacking.ResidualSpaces.Remove(ep);
-          }
-        }
+        }        
       }
       return;
@@ -81,18 +85,73 @@
     /// <returns></returns>
     protected override bool AddExtremePoint(BinPacking3D binPacking, PackingPosition position) {
-      if (binPacking.ExtremePoints.Add(position)) {
-        var rs = CalculateResidualSpace(binPacking, new Vector3D(position));
-        binPacking.ResidualSpaces.Add(position, rs);
-        // Check if the existing extreme points are shadowed by the new point
-        // This is, their residual space fit entirely into the residual space of the new point
-        foreach (var ep in binPacking.ExtremePoints.Where(x => x != position && new Vector3D(x).IsInside(position, rs)).ToList()) {
-          if (IsWithinResidualSpaceOfAnotherExtremePoint(new Vector3D(ep), binPacking.ResidualSpaces[ep], position, rs)) {
+      if (binPacking.ExtremePoints.ContainsKey(position)) {
+        return false;
+      }
+
+      var residualSpaces = CalculateResidualSpace(binPacking, new Vector3D(position));
+      binPacking.ExtremePoints.Add(position, residualSpaces);
+      // Check if the existing extreme points are shadowed by the new point
+      // This is, their residual space fit entirely into the residual space of the new point
+      foreach (var ep in binPacking.ExtremePoints.Where(x => x.Key != position && new Vector3D(x.Key).IsInside(position, residualSpaces)).ToList()) {
+        foreach (var residualSpace in ep.Value) {
+          if (IsWithinResidualSpaceOfAnotherExtremePoint(new Vector3D(ep.Key), residualSpace, position, residualSpaces)) {
             binPacking.ExtremePoints.Remove(ep);
-            binPacking.ResidualSpaces.Remove(ep);
+            break;
           }
+        }          
+      }
+      return true;
+    }
+
+    /// <summary>
+    /// Calculates the residual space for a given bin packing and position.
+    /// It returns the residual space as a tuple which contains the dimensions
+    /// </summary>
+    /// <param name="binPacking"></param>
+    /// <param name="pos"></param>
+    /// <returns>A Tuple(width, Height, Depth)</width></returns>
+    protected override IEnumerable<ResidualSpace> CalculateResidualSpace(BinPacking3D binPacking, Vector3D pos) {
+      var residualSpaces = new List<ResidualSpace>();
+      var residualSpace = new ResidualSpace(CalculateResidualSpaceOld(binPacking, pos));
+      if (!residualSpace.IsZero()) {
+        residualSpaces.Add(residualSpace);
+      }
+      return residualSpaces;
+    }
+
+    protected Tuple<int, int, int> CalculateResidualSpaceOld(BinPacking3D binPacking, Vector3D pos) {
+
+      if (pos == null) {
+        return Tuple.Create(0, 0, 0);
+      }
+      var itemPos = binPacking.Items.Select(x => new {
+        Item = x.Value,
+        Position = binPacking.Positions[x.Key]
+      });
+      Vector3D limit = new Vector3D() {
+        X = binPacking.BinShape.Width,
+        Y = binPacking.BinShape.Height,
+        Z = binPacking.BinShape.Depth
+      };
+
+      if (pos.X < limit.X && pos.Y < limit.Y && pos.Z < limit.Z) {
+        var rightLimit = ProjectRight(binPacking, pos);
+        var upLimit = ProjectUp(binPacking, pos);
+        var forwardLimit = ProjectForward(binPacking, pos);
+        if (rightLimit.X > 0) {
+          limit.X = rightLimit.X;
         }
-        return true;
+        if (upLimit.Y > 0) {
+          limit.Y = upLimit.Y;
+        }
+        if (forwardLimit.Z > 0) {
+          limit.Z = forwardLimit.Z;
+        }
       }
-      return false;
+
+      if (limit.X - pos.X <= 0 || limit.Y - pos.Y <= 0 || limit.Z - pos.Z <= 0) {
+        return Tuple.Create(0, 0, 0);
+      }
+      return Tuple.Create(limit.X - pos.X, limit.Y - pos.Y, limit.Z - pos.Z);
     }
   }
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Edge3D.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Edge3D.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Edge3D.cs	(revision 15554)
@@ -70,5 +70,5 @@
       });
       Vector3D point = l1.Intersect(l2);
-      if (e1.LiesOn(point) && e2.LiesOn(point)) {
+      if (point != null && e1.LiesOn(point) && e2.LiesOn(point)) {
         return point;
       }
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Line3D.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Line3D.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Line3D.cs	(revision 15554)
@@ -9,5 +9,5 @@
   /// A line is given as a point and a directing vector
   /// </summary>
-  internal class Line3D {
+  public class Line3D {
     public Vector3D Point;
     public Vector3D Direction;
@@ -30,7 +30,18 @@
     }
 
+    /// <summary>
+    /// Returns the intersection point of two lines.
+    /// It the lines doesn't intersect it returns null.
+    /// </summary>
+    /// <param name="line"></param>
+    /// <returns></returns>
     public Vector3D Intersect(Line3D line) {
       double r = 0;
       double s = 0;
+
+      // if they have the same source point, this point can be returned.
+      if (this.Point.Equals(line.Point)) {
+        return this.Point;
+      }
 
       if (Direction.X != 0) {
@@ -49,11 +60,9 @@
         s = (this.Point.Z - line.Point.Z) / (double)line.Direction.Z;
       }
-
-      var a = r * this.Direction + this.Point;
-      var b = s * line.Direction + line.Point;
-      var c = a.Equals(b);
-      if (s!=0 && r!=0 && a.Equals(b)) {
-        
-        return a;
+      var p1 = r * this.Direction + this.Point;
+      var p2 = s * line.Direction + line.Point;
+      var c = p1.Equals(p2);
+      if (s!=0 && r!=0 && p1.Equals(p2)) {        
+        return p1;
       }
 
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Plane3D.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Plane3D.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Plane3D.cs	(revision 15554)
@@ -6,14 +6,15 @@
 
 namespace HeuristicLab.Problems.BinPacking3D.Geometry {
-  internal enum Side { Top, Left, Bottom, Right, Front, Back }
+  public enum Side { Top, Left, Bottom, Right, Front, Back }
 
   /// <summary>
   /// A plane is given as a point and two directing vectors
   /// </summary>
-  internal class Plane3D {
+  public class Plane3D {
     public Vector3D Point { get; private set; }
     public Vector3D Direction1 { get; private set; }
     public Vector3D Direction2 { get; private set; }
     public Vector3D Normal { get; private set; }
+
     private int rhs;
 
@@ -93,12 +94,28 @@
     }
 
+    /// <summary>
+    /// Returns true if the given point is an element of the current plane
+    /// </summary>
+    /// <param name="point"></param>
+    /// <returns></returns>
     public bool IsElementOf(Vector3D point) {
       return Normal.X * point.X + Normal.Y * point.Y + Normal.Z * point.Z == rhs;
     }
 
+    /// <summary>
+    /// Returns true, if the given line intersects with the current plane
+    /// </summary>
+    /// <param name="line"></param>
+    /// <returns></returns>
     public bool Intersects(Line3D line) {
       return Intersect(line) != null;
     }
 
+    /// <summary>
+    /// Returns the point of intersection of a given line and the current plane.
+    /// It returns null if there is no intersection.
+    /// </summary>
+    /// <param name="line"></param>
+    /// <returns></returns>
     public Vector3D Intersect(Line3D line) {
       var denom = Normal * line.Direction;
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Vector3D.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Vector3D.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Geometry/Vector3D.cs	(revision 15554)
@@ -12,5 +12,9 @@
     public int Z { get; set; }
 
-    public Vector3D() { }
+    public Vector3D() {
+      X = 0;
+      Y = 0;
+      Z = 0;
+    }
     public Vector3D(int x, int y, int z) {
       X = x;
@@ -85,4 +89,8 @@
     }
 
+    public bool IsInside(PackingPosition pos, IEnumerable<ResidualSpace> rs) {
+      return rs.Any(x => IsInside(pos, x));
+    }
+
     public static int operator *(Vector3D a, Vector3D b) {
       return a.X * b.X + a.Y * b.Y + a.Z * b.Z;
